/****************************************************************/
/*  
     ***   ***  ***  *** ***     *** ***   ******  ****  ***
     ***   ***  ***  *** ***     *** **   ***  *** ***** ***
     ***   ***  ***  *** ***     *****    ******** *** *****
      *** ***   ***  *** ******* *** **   ***  *** ***  ****
       *****     *****   ******* *** ***  ***  *** ***   ***
	   
	 Vulkan Graphics API: 11 Steps

     Minimalistic examples to build upon and experiment with 
	 to develop an understanding of the underlying API

	   
/*
/****************************************************************/

// Tessellation Control Shader

#version 450

#extension GL_ARB_separate_shader_objects : enable
#extension GL_ARB_shading_language_420pack : enable

// output format
layout (vertices = 4) out;


// input into the shader
layout ( location = 0 ) in  vec4 inPos[];
layout ( location = 1 ) in  vec4 inColor[];
layout ( location = 2 ) in  vec2 inTexCoords[];
layout ( location = 3 ) in  vec3 inNormal[];


// output to next stage
layout ( location = 0 ) out vec4 outPos[4];
layout ( location = 1 ) out vec4 outColor[4];
layout ( location = 2 ) out vec2 outTexCoords[4];
layout ( location = 3 ) out vec3 outNormal[4];


void main(void)
{
    if (gl_InvocationID == 0)
    {
        gl_TessLevelInner[0] = 8.0;
		gl_TessLevelInner[1] = 8.0;
        gl_TessLevelOuter[0] = 8.0;
        gl_TessLevelOuter[1] = 8.0;
        gl_TessLevelOuter[2] = 8.0;
        gl_TessLevelOuter[3] = 8.0;
    }

    // Default transform position
    gl_out[gl_InvocationID].gl_Position = gl_in[gl_InvocationID].gl_Position;

    outPos[gl_InvocationID]       = inPos[gl_InvocationID];
    outColor[gl_InvocationID]     = inColor[gl_InvocationID];
    outTexCoords[gl_InvocationID] = inTexCoords[gl_InvocationID];
    outNormal[gl_InvocationID]    = inNormal[gl_InvocationID];

}// End main(..)